diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
index f4d6fda8c..7d3ab1f45 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
@@ -23,11 +23,13 @@ import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.InventorySorter;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
+import org.joml.Vector3dc;
+import org.joml.primitives.AABBd;
 
 import java.util.List;
 
@@ -46,44 +48,44 @@ public class EntityMinecart extends Entity implements Container {
     // 10 x 2 x 3 table of something
     private static final int[][][] EXITS = {
         {
-            {  0,  0, -1 }, // STRAIGHT_NS
-            {  0,  0,  1 }
+            {0, 0, -1}, // STRAIGHT_NS
+            {0, 0, 1}
         },
         {
-            { -1,  0,  0 }, // STRAIGHT_EW
-            {  1,  0,  0 }
+            {-1, 0, 0}, // STRAIGHT_EW
+            {1, 0, 0}
         },
         {
-            { -1, -1,  0 }, // SLOPE_E
-            {  1,  0,  0 }
+            {-1, -1, 0}, // SLOPE_E
+            {1, 0, 0}
         },
         {
-            { -1,  0,  0 }, // SLOPE_W
-            {  1, -1,  0 }
+            {-1, 0, 0}, // SLOPE_W
+            {1, -1, 0}
         },
         {
-            {  0,  0, -1 }, // SLOPE_N
-            {  0, -1, 1  }
+            {0, 0, -1}, // SLOPE_N
+            {0, -1, 1}
         },
         {
-            {  0, -1, -1 }, // SLOPE_S
-            {  0,  0,  1 }
+            {0, -1, -1}, // SLOPE_S
+            {0, 0, 1}
         },
         {
-            {  0,  0,  1 }, // TURN_ES
-            {  1,  0,  0 }
+            {0, 0, 1}, // TURN_ES
+            {1, 0, 0}
         },
         {
-            {  0,  0,  1 }, // TURN_WS
-            { -1,  0,  0 }
+            {0, 0, 1}, // TURN_WS
+            {-1, 0, 0}
         },
         {
-            {  0,  0, -1 }, // TURN_WN
-            { -1,  0,  0 }
+            {0, 0, -1}, // TURN_WN
+            {-1, 0, 0}
         },
         {
-            {  0,  0, -1 }, // TURN_EN
-            {  1,  0,  0 }
+            {0, 0, -1}, // TURN_EN
+            {1, 0, 0}
         }
     };
     private ItemStack[] items;
@@ -106,67 +108,88 @@ public class EntityMinecart extends Entity implements Container {
 
     public EntityMinecart(World world) {
         super(world);
-        items = new ItemStack[36];
-        currentDamage = 0;
-        timeSinceHit = 0;
-        hurtDirection = 1;
-        flipped = false;
-        blocksBuilding = true;
+        this.items = new ItemStack[36];
+        this.currentDamage = 0;
+        this.timeSinceHit = 0;
+        this.hurtDirection = 1;
+        this.flipped = false;
+        this.blocksBuilding = true;
         setSize(0.98F, 0.7F);
-        heightOffset = bbHeight / 2.0F;
+        this.heightOffset = this.bbHeight / 2.0F;
     }
+
     public EntityMinecart(World world, double x, double y, double z, int type) {
         this(world);
-        setPos(x, y + (double) heightOffset, z);
-        xd = 0.0D;
-        yd = 0.0D;
-        zd = 0.0D;
-        xo = x;
-        yo = y;
-        zo = z;
+        setPos(x, y + (double) this.heightOffset, z);
+        this.xd = 0.0D;
+        this.yd = 0.0D;
+        this.zd = 0.0D;
+        this.xo = x;
+        this.yo = y;
+        this.zo = z;
         setType((byte) type);
     }
+
     @Override
     public float getShadowHeightOffs() {
         return 0.0F;
     }
+
     @Override
-	protected boolean makeStepSound() {
+    protected boolean makeStepSound() {
         return false;
     }
+
     @Override
-	protected void defineSynchedData() {
-        entityData.define(DATA_TYPE, (byte)0, Byte.class);
-        entityData.define(DATA_META, 0, Integer.class);
-        entityData.define(DATA_FUEL, 0, Integer.class);
+    protected void defineSynchedData() {
+        this.entityData.define(DATA_TYPE, (byte) 0, Byte.class);
+        this.entityData.define(DATA_META, 0, Integer.class);
+        this.entityData.define(DATA_FUEL, 0, Integer.class);
     }
 
-    public void setType(byte type) {entityData.set(DATA_TYPE, type);}
-    public byte getType() {return entityData.getByte(DATA_TYPE);}
+    public void setType(byte type) {
+        this.entityData.set(DATA_TYPE, type);
+    }
 
-    public void setMeta(int meta) {entityData.set(DATA_META, meta);}
-    public int getMeta() {return entityData.getInt(DATA_META);}
+    public byte getType() {
+        return this.entityData.getByte(DATA_TYPE);
+    }
 
-    public void setFuel(int fuel) {entityData.set(DATA_FUEL, fuel);}
-    public int getFuel() {return entityData.getInt(DATA_FUEL);}
+    public void setMeta(int meta) {
+        this.entityData.set(DATA_META, meta);
+    }
+
+    public int getMeta() {
+        return this.entityData.getInt(DATA_META);
+    }
+
+    public void setFuel(int fuel) {
+        this.entityData.set(DATA_FUEL, fuel);
+    }
+
+    public int getFuel() {
+        return this.entityData.getInt(DATA_FUEL);
+    }
 
 
     @Override
-	public boolean isPushable() {
+    public boolean isPushable() {
         return true;
     }
+
     @Override
     public boolean isPickable() {
-        return !removed;
+        return !this.removed;
     }
+
     @Override
     public double getRideHeight() {
-        return (double) bbHeight * 0.0D - 0.3D;
+        return (double) this.bbHeight * 0.0D - 0.3D;
     }
 
     @Override
     public Entity ejectRider() {
-        Entity entity = passenger;
+        Entity entity = this.passenger;
         if (entity == null) return null;
 
         this.passenger = null;
@@ -192,31 +215,31 @@ public class EntityMinecart extends Entity implements Container {
     }
 
     private boolean isSafe(int x, int y, int z) {
-        return !world.isBlockNormalCube(x, y, z) && !world.isBlockNormalCube(x, y + 1, z);
+        return !this.world.isBlockNormalCube(x, y, z) && !this.world.isBlockNormalCube(x, y + 1, z);
     }
 
     @Override
     public boolean hurt(Entity entity, int baseDamage, DamageType type) {
-        if(world.isClientSide || removed) {
+        if (this.world.isClientSide || this.removed) {
             return true;
         }
-        if(entity instanceof Player) {
-        	if(((Player) entity).getGamemode() == Gamemode.creative) {
-        		remove();
-        		return true;
-        	}
+        if (entity instanceof Player player) {
+            if (player.getGamemode() == Gamemode.creative) {
+                remove();
+                return true;
+            }
         }
-        hurtDirection = -hurtDirection;
-        timeSinceHit = 10;
+        this.hurtDirection = -this.hurtDirection;
+        this.timeSinceHit = 10;
         markHurt();
-        currentDamage += baseDamage * 10;
-        if(currentDamage > 40) {
-            if(passenger != null) {
-                passenger.startRiding(this);
+        this.currentDamage += baseDamage * 10;
+        if (this.currentDamage > 40) {
+            if (this.passenger != null) {
+                this.passenger.startRiding(this);
             }
-            if (!world.isClientSide){
+            if (!this.world.isClientSide) {
                 dropItem(Items.MINECART.id, 1, 0.0F);
-                switch (getType()){
+                switch (getType()) {
                     case CHEST_CART:
                         if ((getMeta() & TYPE_MASK_PAINTED_CHEST) != 0) {
                             dropItem(new ItemStack(Blocks.CHEST_PLANKS_OAK_PAINTED, 1, getMeta() & TYPE_MASK_COLOR), 0.0F);
@@ -235,26 +258,26 @@ public class EntityMinecart extends Entity implements Container {
     }
 
     @Override
-	public void animateHurt() {
-        hurtDirection = -hurtDirection;
-        timeSinceHit = 10;
-        currentDamage += currentDamage * 10;
+    public void animateHurt() {
+        this.hurtDirection = -this.hurtDirection;
+        this.timeSinceHit = 10;
+        this.currentDamage += this.currentDamage * 10;
     }
 
     @Override
-	public void remove() {
-        if (!world.isClientSide){
-            for(int j = 0; j < this.getContainerSize(); j++) {
+    public void remove() {
+        if (!this.world.isClientSide) {
+            for (int j = 0; j < this.getContainerSize(); j++) {
                 ItemStack itemStack = this.getItem(j);
-                if(itemStack == null) continue;
+                if (itemStack == null) continue;
 
                 final float range = 0.7F;
-                double x1 = (double) (random.nextFloat() * range) + (double) (1.0F - range) * 0.5D;
-                double y1 = (double) (random.nextFloat() * range) + (double) (1.0F - range) * 0.5D;
-                double z1 = (double) (random.nextFloat() * range) + (double) (1.0F - range) * 0.5D;
-                EntityItem entityItem = new EntityItem(world, x + x1, y + y1, z + z1, itemStack);
+                double x1 = (double) (this.random.nextFloat() * range) + (double) (1.0F - range) * 0.5D;
+                double y1 = (double) (this.random.nextFloat() * range) + (double) (1.0F - range) * 0.5D;
+                double z1 = (double) (this.random.nextFloat() * range) + (double) (1.0F - range) * 0.5D;
+                EntityItem entityItem = new EntityItem(this.world, this.x + x1, this.y + y1, this.z + z1, itemStack);
                 entityItem.pickupDelay = 10;
-                world.entityJoinedWorld(entityItem);
+                this.world.entityJoinedWorld(entityItem);
                 entityItem.xd *= 0.5;
                 entityItem.yd *= 0.5;
                 entityItem.zd *= 0.5;
@@ -267,34 +290,34 @@ public class EntityMinecart extends Entity implements Container {
     }
 
     @Override
-	public void tick() {
-        if(timeSinceHit > 0) timeSinceHit--;
-        if(currentDamage > 0) currentDamage--;
+    public void tick() {
+        if (this.timeSinceHit > 0) this.timeSinceHit--;
+        if (this.currentDamage > 0) this.currentDamage--;
 
-        pushesThisTick = 0;
-        pushTime *= 0.98f;
-        if (pushTime < 0.05f || (pushTime < 0.25 && onGround)){
-            pushTime = 0;
+        this.pushesThisTick = 0;
+        this.pushTime *= 0.98f;
+        if (this.pushTime < 0.05f || (this.pushTime < 0.25 && this.onGround)) {
+            this.pushTime = 0;
         }
 
 
-        double _xo = x;
-        double _yo = y;
-        double _zo = z;
-        float _yRot = yRot;
-        float _xRot = xRot;
-        if (world.isClientSide){
-            if (lerpTicks > 0){
-                double newX = x + (lerpX - x) / (double) lerpTicks;
-                double newY = y + (lerpY - y) / (double) lerpTicks;
-                double newZ = z + (lerpZ - z) / (double) lerpTicks;
+        double _xo = this.x;
+        double _yo = this.y;
+        double _zo = this.z;
+        float _yRot = this.yRot;
+        float _xRot = this.xRot;
+        if (this.world.isClientSide) {
+            if (this.lerpTicks > 0) {
+                double newX = this.x + (this.lerpX - this.x) / (double) this.lerpTicks;
+                double newY = this.y + (this.lerpY - this.y) / (double) this.lerpTicks;
+                double newZ = this.z + (this.lerpZ - this.z) / (double) this.lerpTicks;
 
-                yRot += (float) (MathHelper.normalizeRotation(lerpYRot - (double) yRot) / lerpTicks);
-                xRot += (float) (MathHelper.normalizeRotation(lerpXRot - (double) xRot) / lerpTicks);
+                this.yRot += (float) (MathHelper.normalizeRotation(this.lerpYRot - (double) this.yRot) / this.lerpTicks);
+                this.xRot += (float) (MathHelper.normalizeRotation(this.lerpXRot - (double) this.xRot) / this.lerpTicks);
 
-                lerpTicks--;
+                this.lerpTicks--;
                 setPos(newX, newY, newZ);
-                setRot(yRot, xRot);
+                setRot(this.yRot, this.xRot);
             }
         } else {
             motionIteration();
@@ -308,100 +331,101 @@ public class EntityMinecart extends Entity implements Container {
     }
 
     public void motionIteration() {
-        xo = x;
-        yo = y;
-        zo = z;
-        yd -= 0.04D;
-        int blockX = MathHelper.floor(x);
-        int blockY = MathHelper.floor(y);
-        int blockZ = MathHelper.floor(z);
-        if(BlockLogicRail.isRailBlockAt(world, new TilePos(blockX, blockY - 1, blockZ))) {
+        this.xo = this.x;
+        this.yo = this.y;
+        this.zo = this.z;
+        this.yd -= 0.04D;
+        int blockX = MathHelper.floor(this.x);
+        int blockY = MathHelper.floor(this.y);
+        int blockZ = MathHelper.floor(this.z);
+        TilePos tilePos = new TilePos(this.x, this.y, this.z);
+        TilePos queryPos = new TilePos();
+        if (BlockLogicRail.isRailBlockAt(this.world, tilePos.down(queryPos))) {
             blockY--;
         }
         final double maxSpeed = 0.4D;
         boolean didFurnacePush = false;
         final double d5 = 0.0078125D;
-        Block<?> block = world.getBlock(blockX, blockY, blockZ);
-        if(block != null && block.getLogic() instanceof BlockLogicRail) {
-            BlockLogicRail rail = (BlockLogicRail) block.getLogic();
-            Vec3 vec3d = getPos(x, y, z);
-            y = blockY;
+        Block<?> block = this.world.getBlock(tilePos);
+        if (block != null && block.getLogic() instanceof BlockLogicRail rail) {
+            Vector3dc vec3d = getPos(this.x, this.y, this.z);
+            this.y = blockY;
             boolean onPoweredPoweredRail = false;
             boolean onUnpoweredPoweredRail = false;
-            if(block == Blocks.RAIL_POWERED) {
-                onPoweredPoweredRail = (world.getBlockMetadata(blockX, blockY, blockZ) & 0b1000) != 0;
+            if (block == Blocks.RAIL_POWERED) {
+                onPoweredPoweredRail = (this.world.getBlockData(tilePos) & 0b1000) != 0;
                 onUnpoweredPoweredRail = !onPoweredPoweredRail;
             }
-            RailDirection railDirection = rail.getRailDirection(world, new TilePos(blockX, blockY, blockZ));
+            RailDirection railDirection = rail.getRailDirection(this.world, new TilePos(tilePos));
 
-            if(railDirection.isSloped()) {
-                y = blockY + 1;
+            if (railDirection.isSloped()) {
+                this.y = blockY + 1;
             }
-            if(railDirection == RailDirection.SLOPE_E) {
-                xd -= d5;
+            if (railDirection == RailDirection.SLOPE_E) {
+                this.xd -= d5;
             }
-            if(railDirection == RailDirection.SLOPE_W) {
-                xd += d5;
+            if (railDirection == RailDirection.SLOPE_W) {
+                this.xd += d5;
             }
-            if(railDirection == RailDirection.SLOPE_N) {
-                zd += d5;
+            if (railDirection == RailDirection.SLOPE_N) {
+                this.zd += d5;
             }
-            if(railDirection == RailDirection.SLOPE_S) {
-                zd -= d5;
+            if (railDirection == RailDirection.SLOPE_S) {
+                this.zd -= d5;
             }
             int[][] nextRailTable = EXITS[railDirection.meta];
             double d9 = nextRailTable[1][0] - nextRailTable[0][0];
             double d10 = nextRailTable[1][2] - nextRailTable[0][2];
             double d11 = Math.sqrt(d9 * d9 + d10 * d10);
-            double d12 = xd * d9 + zd * d10;
-            if(d12 < 0.0D) {
+            double d12 = this.xd * d9 + this.zd * d10;
+            if (d12 < 0.0D) {
                 d9 = -d9;
                 d10 = -d10;
             }
 
-            double vel = Math.hypot(xd, zd);
-            xd = (vel * d9) / d11;
-            zd = (vel * d10) / d11;
-            if(onUnpoweredPoweredRail) { // Speed penalty
+            double vel = Math.hypot(this.xd, this.zd);
+            this.xd = (vel * d9) / d11;
+            this.zd = (vel * d10) / d11;
+            if (onUnpoweredPoweredRail) { // Speed penalty
                 // If current speed below threshold kill all motion
-                if(Math.hypot(xd, zd) < 0.03D) {
-                    xd *= 0.0D;
-                    yd *= 0.0D;
-                    zd *= 0.0D;
+                if (Math.hypot(this.xd, this.zd) < 0.03D) {
+                    this.xd *= 0.0D;
+                    this.yd *= 0.0D;
+                    this.zd *= 0.0D;
                 } else {
-                    xd *= 0.5D;
-                    yd *= 0.0D;
-                    zd *= 0.5D;
+                    this.xd *= 0.5D;
+                    this.yd *= 0.0D;
+                    this.zd *= 0.5D;
                 }
             }
-            double d18 = (double)blockX + 0.5D + (double)nextRailTable[0][0] * 0.5D;
-            double d19 = (double)blockZ + 0.5D + (double)nextRailTable[0][2] * 0.5D;
-            double d20 = (double)blockX + 0.5D + (double)nextRailTable[1][0] * 0.5D;
-            double d21 = (double)blockZ + 0.5D + (double)nextRailTable[1][2] * 0.5D;
+            double d18 = (double) blockX + 0.5D + (double) nextRailTable[0][0] * 0.5D;
+            double d19 = (double) blockZ + 0.5D + (double) nextRailTable[0][2] * 0.5D;
+            double d20 = (double) blockX + 0.5D + (double) nextRailTable[1][0] * 0.5D;
+            double d21 = (double) blockZ + 0.5D + (double) nextRailTable[1][2] * 0.5D;
             d9 = d20 - d18;
             d10 = d21 - d19;
             double d17;
-            if(d9 == 0.0D) {
-                d17 = z - (double)blockZ;
-            } else if(d10 == 0.0D) {
-                d17 = x - (double)blockX;
+            if (d9 == 0.0D) {
+                d17 = this.z - (double) blockZ;
+            } else if (d10 == 0.0D) {
+                d17 = this.x - (double) blockX;
             } else {
-                double d22 = x - d18;
-                double d24 = z - d19;
+                double d22 = this.x - d18;
+                double d24 = this.z - d19;
                 d17 = (d22 * d9 + d24 * d10) * 2D;
             }
-            x = d18 + d9 * d17;
-            z = d19 + d10 * d17;
-            setPos(x, y + (double) heightOffset, z);
+            this.x = d18 + d9 * d17;
+            this.z = d19 + d10 * d17;
+            setPos(this.x, this.y + (double) this.heightOffset, this.z);
 
             // Let passenger push minecart slowly
-            if(passenger != null && passenger instanceof Player && Math.hypot(xd, zd) < 0.01f) {
-                xd += passenger.xd * 0.05;
-                zd += passenger.zd * 0.05;
+            if (this.passenger != null && this.passenger instanceof Player && Math.hypot(this.xd, this.zd) < 0.01f) {
+                this.xd += this.passenger.xd * 0.05;
+                this.zd += this.passenger.zd * 0.05;
             }
-            double _xd = xd;
-            double _zd = zd;
-            if(passenger != null) {
+            double _xd = this.xd;
+            double _zd = this.zd;
+            if (this.passenger != null) {
                 _xd *= 0.75D;
                 _zd *= 0.75D;
             }
@@ -410,155 +434,156 @@ public class EntityMinecart extends Entity implements Container {
             _zd = MathHelper.clamp(_zd, -maxSpeed, maxSpeed);
 
             move(_xd, 0.0D, _zd);
-            if(nextRailTable[0][1] != 0 && MathHelper.floor(x) - blockX == nextRailTable[0][0] && MathHelper.floor(z) - blockZ == nextRailTable[0][2]) {
-                setPos(x, y + (double)nextRailTable[0][1], z);
-            } else if(nextRailTable[1][1] != 0 && MathHelper.floor(x) - blockX == nextRailTable[1][0] && MathHelper.floor(z) - blockZ == nextRailTable[1][2]) {
-                setPos(x, y + (double)nextRailTable[1][1], z);
+            if (nextRailTable[0][1] != 0 && MathHelper.floor(this.x) - blockX == nextRailTable[0][0] && MathHelper.floor(this.z) - blockZ == nextRailTable[0][2]) {
+                setPos(this.x, this.y + (double) nextRailTable[0][1], this.z);
+            } else if (nextRailTable[1][1] != 0 && MathHelper.floor(this.x) - blockX == nextRailTable[1][0] && MathHelper.floor(this.z) - blockZ == nextRailTable[1][2]) {
+                setPos(this.x, this.y + (double) nextRailTable[1][1], this.z);
             }
-            if(passenger != null) {
-                xd *= 0.997D;
-                yd *= 0.0D;
-                zd *= 0.997D;
+            if (this.passenger != null) {
+                this.xd *= 0.997D;
+                this.yd *= 0.0D;
+                this.zd *= 0.997D;
             } else {
-                if(getType() == FURNACE_CART) {
-                    vel = Math.hypot(xPush, zPush);
-                    if(vel > 0.01D) {
+                if (getType() == FURNACE_CART) {
+                    vel = Math.hypot(this.xPush, this.zPush);
+                    if (vel > 0.01D) {
                         didFurnacePush = true;
-                        xPush /= vel;
-                        zPush /= vel;
-                        xd *= 0.8D;
-                        yd *= 0.0D;
-                        zd *= 0.8D;
+                        this.xPush /= vel;
+                        this.zPush /= vel;
+                        this.xd *= 0.8D;
+                        this.yd *= 0.0D;
+                        this.zd *= 0.8D;
                         final double pushScalar = 0.04D;
-                        xd += xPush * pushScalar;
-                        zd += zPush * pushScalar;
+                        this.xd += this.xPush * pushScalar;
+                        this.zd += this.zPush * pushScalar;
                     } else {
-                        xd *= 0.9D;
-                        yd *= 0.0D;
-                        zd *= 0.9D;
+                        this.xd *= 0.9D;
+                        this.yd *= 0.0D;
+                        this.zd *= 0.9D;
                     }
                 }
-                xd *= 0.96D;
-                yd *= 0.0D;
-                zd *= 0.96D;
+                this.xd *= 0.96D;
+                this.yd *= 0.0D;
+                this.zd *= 0.96D;
             }
-            Vec3 vec3d1 = getPos(x, y, z);
-            if(vec3d1 != null && vec3d != null) {
-                double slopeSpeedOffset = (vec3d.y - vec3d1.y) * 0.05D; // I think this give a speed buff/penalty for going up/down slopes
-                vel = Math.hypot(xd, zd);
-                if(vel > 0.0D) {
-                    xd = (xd / vel) * (vel + slopeSpeedOffset);
-                    zd = (zd / vel) * (vel + slopeSpeedOffset);
+            Vector3dc vec3d1 = getPos(this.x, this.y, this.z);
+            if (vec3d1 != null && vec3d != null) {
+                double slopeSpeedOffset = (vec3d.y() - vec3d1.y()) * 0.05D; // I think this give a speed buff/penalty for going up/down slopes
+                vel = Math.hypot(this.xd, this.zd);
+                if (vel > 0.0D) {
+                    this.xd = (this.xd / vel) * (vel + slopeSpeedOffset);
+                    this.zd = (this.zd / vel) * (vel + slopeSpeedOffset);
                 }
-                setPos(x, vec3d1.y, z);
+                setPos(this.x, vec3d1.y(), this.z);
             }
-            int newBlockX = MathHelper.floor(x);
-            int newBlockZ = MathHelper.floor(z);
-            if(newBlockX != blockX || newBlockZ != blockZ) {
-                vel = Math.hypot(xd, zd);
-                xd = vel * (double)(newBlockX - blockX);
-                zd = vel * (double)(newBlockZ - blockZ);
+            int newBlockX = MathHelper.floor(this.x);
+            int newBlockZ = MathHelper.floor(this.z);
+            if (newBlockX != blockX || newBlockZ != blockZ) {
+                vel = Math.hypot(this.xd, this.zd);
+                this.xd = vel * (double) (newBlockX - blockX);
+                this.zd = vel * (double) (newBlockZ - blockZ);
             }
-            if(getType() == FURNACE_CART) {
-                double pushMagnitude = Math.hypot(xPush, zPush);
-                if(pushMagnitude > 0.01D && Math.hypot(xd, zd) > 0.001D) {
-                    xPush = xd;
-                    zPush = zd;
+            if (getType() == FURNACE_CART) {
+                double pushMagnitude = Math.hypot(this.xPush, this.zPush);
+                if (pushMagnitude > 0.01D && Math.hypot(this.xd, this.zd) > 0.001D) {
+                    this.xPush = this.xd;
+                    this.zPush = this.zd;
                 }
             }
-            if(onPoweredPoweredRail) { // Speed boost
-                vel = Math.hypot(xd, zd);
-                if(vel > 0.01D) {
+            if (onPoweredPoweredRail) { // Speed boost
+                vel = Math.hypot(this.xd, this.zd);
+                if (vel > 0.01D) {
                     final double scalar = 0.06D;
-                    xd += (xd / vel) * scalar;
-                    zd += (zd / vel) * scalar;
-                } else if(railDirection == RailDirection.STRAIGHT_EW) {
-                    if(world.isBlockNormalCube(blockX - 1, blockY, blockZ)) {
-                        xd = 0.02D;
-                    } else if(world.isBlockNormalCube(blockX + 1, blockY, blockZ)) {
-                        xd = -0.02D;
+                    this.xd += (this.xd / vel) * scalar;
+                    this.zd += (this.zd / vel) * scalar;
+                } else if (railDirection == RailDirection.STRAIGHT_EW) {
+                    if (this.world.isBlockNormalCube(tilePos.west(queryPos))) {
+                        this.xd = 0.02D;
+                    } else if (this.world.isBlockNormalCube(tilePos.east(queryPos))) {
+                        this.xd = -0.02D;
                     }
-                } else if(railDirection == RailDirection.STRAIGHT_NS) {
-                    if(world.isBlockNormalCube(blockX, blockY, blockZ - 1)) {
-                        zd = 0.02D;
-                    } else if(world.isBlockNormalCube(blockX, blockY, blockZ + 1)) {
-                        zd = -0.02D;
+                } else if (railDirection == RailDirection.STRAIGHT_NS) {
+                    if (this.world.isBlockNormalCube(tilePos.north(queryPos))) {
+                        this.zd = 0.02D;
+                    } else if (this.world.isBlockNormalCube(tilePos.south(queryPos))) {
+                        this.zd = -0.02D;
                     }
                 }
             }
         } else {
-            xd = MathHelper.clamp(xd, -maxSpeed, maxSpeed);
-            zd = MathHelper.clamp(zd, -maxSpeed, maxSpeed);
+            this.xd = MathHelper.clamp(this.xd, -maxSpeed, maxSpeed);
+            this.zd = MathHelper.clamp(this.zd, -maxSpeed, maxSpeed);
 
-            if(onGround) {
-                xd *= 0.5D;
-                yd *= 0.5D;
-                zd *= 0.5D;
+            if (this.onGround) {
+                this.xd *= 0.5D;
+                this.yd *= 0.5D;
+                this.zd *= 0.5D;
             }
-            move(xd, yd, zd);
-            if(!onGround) {
-                xd *= 0.95D;
-                yd *= 0.95D;
-                zd *= 0.95D;
+            move(this.xd, this.yd, this.zd);
+            if (!this.onGround) {
+                this.xd *= 0.95D;
+                this.yd *= 0.95D;
+                this.zd *= 0.95D;
             }
         }
-        xRot = 0.0F;
-        double diffX = xo - x;
-        double diffZ = zo - z;
-        if(Math.hypot(diffX, diffZ) > 0.001D) {
-            yRot = (float) Math.toDegrees(Math.atan2(diffZ, diffX));
-            if(flipped) {
-                yRot += 180F;
+        this.xRot = 0.0F;
+        double diffX = this.xo - this.x;
+        double diffZ = this.zo - this.z;
+        if (Math.hypot(diffX, diffZ) > 0.001D) {
+            this.yRot = (float) Math.toDegrees(Math.atan2(diffZ, diffX));
+            if (this.flipped) {
+                this.yRot += 180F;
             }
         }
 
-        double diffYRot = MathHelper.normalizeRotation(yRot - yRotO);
+        double diffYRot = MathHelper.normalizeRotation(this.yRot - this.yRotO);
 
         // Cause minecart to flip 180?
-        if(diffYRot < -170D || diffYRot >= 170D) {
-            yRot += 180F;
-            flipped = !flipped;
+        if (diffYRot < -170D || diffYRot >= 170D) {
+            this.yRot += 180F;
+            this.flipped = !this.flipped;
         }
 
-        setRot(yRot, xRot);
-        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.expand(0.2D, 0.0D, 0.2));
-        if(list != null && !list.isEmpty()) {
+        setRot(this.yRot, this.xRot);
+        List<Entity> list = this.world.getEntitiesWithinAABBExcludingEntity(this, MathHelper.aabbExpand(this.bb, 0.2D, 0.0D, 0.2, new AABBd()));
+        if (!list.isEmpty()) {
             for (Entity entity : list) {
-                if ((entity instanceof EntityMinecart) && entity != passenger && entity.isPushable()) {
+                if ((entity instanceof EntityMinecart) && entity != this.passenger && entity.isPushable()) {
                     entity.push(this);
                 }
             }
         }
-        if(passenger != null && passenger.removed) {
-            passenger = null;
+        if (this.passenger != null && this.passenger.removed) {
+            this.passenger = null;
         }
-        if(didFurnacePush && random.nextInt(4) == 0) {
+        if (didFurnacePush && this.random.nextInt(4) == 0) {
             setFuel(getFuel() - 1);
-            if(getFuel() < 0) {
-                xPush = 0.0D;
-                zPush = 0.0D;
+            if (getFuel() < 0) {
+                this.xPush = 0.0D;
+                this.zPush = 0.0D;
             }
-            world.spawnParticle("largesmoke", x, y + 0.8D, z, 0.0D, 0.0D, 0.0D, 0);
+            this.world.spawnParticle("largesmoke", this.x, this.y + 0.8D, this.z, 0.0D, 0.0D, 0.0D, 0);
         }
     }
 
-    public Vec3 getPosOffs(final double x, final double y, final double z, final double scalar /*Not sure what this is for still*/) {
+    public @Nullable Vector3dc getPosOffs(final double x, final double y, final double z, final double scalar /*Not sure what this is for still*/) {
         int blockX = MathHelper.floor(x);
         int blockY = MathHelper.floor(y);
         int blockZ = MathHelper.floor(z);
-        if(BlockLogicRail.isRailBlockAt(world, new TilePos(blockX, blockY - 1, blockZ))) {
+        if (BlockLogicRail.isRailBlockAt(this.world, new TilePos(blockX, blockY - 1, blockZ))) {
             blockY--;
         }
 
-        Block<?> block = world.getBlock(blockX, blockY, blockZ);
-        if (!(block != null && block.getLogic() instanceof BlockLogicRail)) { return null; }
+        Block<?> block = this.world.getBlock(blockX, blockY, blockZ);
+        if (!(block != null && block.getLogic() instanceof BlockLogicRail rail)) {
+            return null;
+        }
 
-        BlockLogicRail rail = (BlockLogicRail) block.getLogic();
-        int meta = world.getBlockMetadata(blockX, blockY, blockZ);
-        if(rail.getIsPowered()) {
+        int meta = this.world.getBlockMetadata(blockX, blockY, blockZ);
+        if (rail.getIsPowered()) {
             meta &= 0b111;
         }
-        if(meta >= 2 && meta <= 5) {
+        if (meta >= 2 && meta <= 5) {
             blockY += 1;
         }
         int[][] ai = EXITS[meta];
